=== debian/changelog ===
purify (5.0.1-2) unstable; urgency=medium

  * Disable 32-bit build on Salsa
  * Disable long running test_integration test

 -- Ole Streicher <olebole@debian.org>  Thu, 02 Oct 2025 09:39:48 +0200

purify (5.0.1-1) unstable; urgency=medium

  * d/watch: update to format version 5.0
  * New upstream version 5.0.1 (Closes: #1113430)
  * Rediff patches
  * Push sopt build-dep minversion to 5.0

 -- Ole Streicher <olebole@debian.org>  Tue, 30 Sep 2025 20:42:44 +0200
