=== debian/control ===
Source: purify
Section: science
Priority: optional
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Gijs Molenaar <gijs@pythonic.nl>, Ole Streicher <olebole@debian.org>
Build-Depends: architecture-is-64-bit,
               casacore-dev,
               catch2,
               cmake,
               debhelper-compat (= 13),
               libblas-dev,
               libboost-dev,
               libboost-filesystem-dev,
               libccfits-dev,
               libcubature-dev,
               libeigen3-dev,
               libfftw3-dev,
               libsopt-dev (>= 5.0~),
               libspdlog-dev,
               libtiff5-dev,
               libyaml-cpp-dev
Standards-Version: 4.7.2
Vcs-Git: https://salsa.debian.org/debian-astro-team/purify.git
Vcs-Browser: https://salsa.debian.org/debian-astro-team/purify
Homepage: https://astro-informatics.github.io/purify/
Rules-Requires-Root: no

Package: purify
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: libpurify-dev
Description: Collection of routines for radio interferometric imaging
 PURIFY is a collection of routines written in C that implements different
 tools for radio interferometric imaging including file handling (for both
 visibilities and fits files), implementation of the measurement operator
 and set-up of the different optimization problems used for image
 deconvolution. The code calls the generic Sparse OPTimization (SOPT)
 package to solve the imaging optimization problems.

Package: libpurify2.0
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Routines for radio interferometric imaging (shared lib)
 PURIFY is a collection of routines written in C that implements different
 tools for radio interferometric imaging including file handling (for both
 visibilities and fits files), implementation of the measurement operator
 and set-up of the different optimization problems used for image
 deconvolution. The code calls the generic Sparse OPTimization (SOPT)
 package to solve the imaging optimization problems.
 .
 This package contains the shared library.

Package: libpurify-dev
Architecture: any
Section: libdevel
Depends: libpurify2.0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Recommends: purify
Description: Routines for radio interferometric imaging (development files)
 PURIFY is a collection of routines written in C that implements different
 tools for radio interferometric imaging including file handling (for both
 visibilities and fits files), implementation of the measurement operator
 and set-up of the different optimization problems used for image
 deconvolution. The code calls the generic Sparse OPTimization (SOPT)
 package to solve the imaging optimization problems.
 .
 This package contains the development files.
